// VCamCOMTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCamCOMTest.h"
#include "VCamCOMTestDlg.h"
#include <GdiPlus.h>

#pragma comment(lib, "gdiplus")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#import "VCamCOM.tlb" no_namespace, raw_interfaces_only exclude("UINT_PTR") 

const CLSID CLSID_VCamSDK = {0x61E348C4,0xCEA8,0x48B6,{0xA7,0xAE,0x87,0xB6,0xD0,0x45,0x90,0xAE}};
const IID	IID_IVCamSDK = {0x7DA47CCB,0x2362,0x48AA,{0x98,0x96,0x52,0x0C,0xBE,0x44,0xEF,0xF7}};


// CVCamCOMTestDlg dialog

BEGIN_DHTML_EVENT_MAP(CVCamCOMTestDlg)
	DHTML_EVENT_ONCLICK(_T("ButtonOK"), OnButtonOK)
	DHTML_EVENT_ONCLICK(_T("ButtonPlayFile"), OnButtonPlayFile)
	DHTML_EVENT_ONCLICK(_T("ButtonSeek"), OnButtonSeek)
	DHTML_EVENT_ONCLICK(_T("ButtonPlayDevice"), OnButtonPlayDevice)
	DHTML_EVENT_ONCLICK(_T("ButtonScreenCapture"), OnButtonScreenCapture)
	DHTML_EVENT_ONCLICK(_T("ButtonPlayBuffer"), OnButtonPlayBuffer)
	DHTML_EVENT_ONCLICK(_T("ButtonOverlay"), OnButtonOverlay)
	DHTML_EVENT_ONCLICK(_T("ButtonStop"), OnButtonStop)
	DHTML_EVENT_ONCLICK(_T("ButtonConfig"), OnButtonConfig)
END_DHTML_EVENT_MAP()


CVCamCOMTestDlg::CVCamCOMTestDlg(CWnd* pParent /*=NULL*/)
	: CDHtmlDialog(CVCamCOMTestDlg::IDD, CVCamCOMTestDlg::IDH, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVCamCOMTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDHtmlDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVCamCOMTestDlg, CDHtmlDialog)
	//}}AFX_MSG_MAP
	ON_WM_CLOSE()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CVCamCOMTestDlg message handlers

BOOL CVCamCOMTestDlg::OnInitDialog()
{
	CDHtmlDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_pVCam = NULL;
	HRESULT hr = CoCreateInstance(CLSID_VCamSDK, NULL, CLSCTX_INPROC, IID_IVCamSDK, 
		reinterpret_cast<void**>(&m_pVCam));

	// m_pVCam->SetVCamDeviceName(_bstr_t("Cam01 Virtual Camera"));
	// m_pVCam->SetLicenseCode(_bstr_t("12345678"));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVCamCOMTestDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	if (m_pVCam)
		m_pVCam->Release();
	CDHtmlDialog::OnClose();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCamCOMTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDHtmlDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCamCOMTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


HRESULT CVCamCOMTestDlg::OnButtonOK(IHTMLElement* /*pElement*/)
{
	SendMessage(WM_CLOSE);
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonPlayFile(IHTMLElement* /*pElement*/)
{
	OnButtonStop(NULL);

	CFileDialog dlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, _T("Video files (*.*)|*.*||"));
	if (IDOK == dlg.DoModal()) {
		HRESULT hr = m_pVCam->PlayVideoFile(_bstr_t(dlg.GetPathName()));
		SetTimer(1, 1000, NULL);
	}	
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonSeek(IHTMLElement* /*pElement*/)
{
	m_pVCam->put_CurrentVideoPosition(30 * 1000);
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonPlayDevice(IHTMLElement* /*pElement*/)
{
	OnButtonStop(NULL);

	int no = 0;

	if (IDYES == MessageBox(_T("Choose [Yes] if VCam is your first Video Capture Device,\n\r")\
		_T("Choose [No] if not.\n\n\rNote: You must have one Video Capture Device to use this feature."), 
		_T("Question"), MB_ICONQUESTION | MB_YESNO)) {
		no = 1;
	}

	HRESULT hr = m_pVCam->PlayVideoDevice(no); // if #1 is e2eCam, change it to #0, or #2...

	SetElementText(_T("test"), _bstr_t(L"Playing video device..."));
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonScreenCapture(IHTMLElement* /*pElement*/)
{
	OnButtonStop(NULL);

	m_pVCam->CaptureScreen(100, 100, 320, 240);

	SetElementText(_T("test"), _bstr_t(L"Capturing screen [100, 100] 320 x 240..."));
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonPlayBuffer(IHTMLElement* /*pElement*/)
{
	OnButtonStop(NULL);

	LPBYTE buffer = new BYTE[320*240*3];
	srand( (unsigned)time( NULL ) );
	for (int i=0; i<320*240*3; i++) {
		buffer[i] = rand()%255;
	}

#if 1

	m_pVCam->PlayBuffer(buffer, 320, 240);

#else // Another way (automation use)

	VARIANT var;
	VariantInit(&var);
	SAFEARRAY *psa;
	SAFEARRAYBOUND rgsabound[1];	

	int buf_size = 320*240*3;

	rgsabound[0].lLbound = 0;
	rgsabound[0].cElements = buf_size;
	psa = SafeArrayCreate(VT_UI1, 1, rgsabound);
	BYTE *pBits;
	SafeArrayAccessData(psa, (void **)&pBits);

	memcpy(pBits, buffer, buf_size);

	SafeArrayUnaccessData(psa);

	var.vt = VT_UI1|VT_ARRAY;
	var.parray = psa;

	m_pVCam->PlayBufferEx(var, 320, 240);

#endif

	delete buffer;

	SetElementText(_T("test"), _bstr_t(L"Sent one buffer"));

	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonOverlay(IHTMLElement* /*pElement*/)
{
	using namespace Gdiplus;
	WCHAR strPath[MAX_PATH] = {0};
	GetModuleFileNameW(AfxGetApp()->m_hInstance, strPath, MAX_PATH);
	PathRemoveFileSpecW(strPath);
	StrCatW(strPath, L"\\star.png");
	Bitmap* png = Bitmap::FromFile(strPath); // a transparent png file
	if (png && png->GetWidth() > 0) {
		Rect rc(0, 0, png->GetWidth(), png->GetHeight());
		BitmapData bd;
		png->LockBits(&rc, ImageLockModeRead, PixelFormat32bppARGB, &bd);
		PBYTE img = (PBYTE) bd.Scan0;

		// RGBA -> ARGB
		BYTE a,r,g,b;
		for (int i=0; i<bd.Height; i++) {
			PBYTE hd = img+i*bd.Stride;
			for (int j=0; j<bd.Width; j++) {
				r = hd[j*4+0];
				g = hd[j*4+1];
				b = hd[j*4+2];
				a = hd[j*4+3];

				hd[j*4+0] = a;
				hd[j*4+1] = r;
				hd[j*4+2] = g;
				hd[j*4+3] = b;
			}
		}

#if 1
		VARIANT var;
		VariantInit(&var);
		SAFEARRAY *psa;
		SAFEARRAYBOUND rgsabound[1];	

		int buf_size = png->GetWidth() * png->GetHeight() * 4;

		rgsabound[0].lLbound = 0;
		rgsabound[0].cElements = buf_size;
		psa = SafeArrayCreate(VT_UI1, 1, rgsabound);
		BYTE *pBits;
		SafeArrayAccessData(psa, (void **)&pBits);

		memcpy(pBits, img, buf_size);

		SafeArrayUnaccessData(psa);

		var.vt = VT_UI1|VT_ARRAY;
		var.parray = psa;

		m_pVCam->AddOverlay(var, png->GetWidth(), png->GetHeight(), 10, 10, 0);
#endif

		png->UnlockBits(&bd);
	}
	// m_pVCam->AddOverlay(NULL, 0, 0, 0, 0, 0); // remove it

    m_pVCam->AddText(_bstr_t(_T("This is text one")), _bstr_t(_T("Comic Sans MS")), -20, 0, RGB(255, 0, 0), RGB(0, 255, 0), 75, 80, 1, 0);
	// m_pVCam->AddText(NULL, NULL, 0, 0, 0, 0, 0, 0); // remove it
	m_pVCam->AddText(_bstr_t(_T("This is text two")), _bstr_t(_T("Comic Sans MS")), -16, 0, RGB(0, 0, 255), RGB(255, 255, 0), 75, 110, 2, 1);	
	m_pVCam->AddText(_bstr_t(_T("This is text three")), _bstr_t(_T("Comic Sans MS")), -16, 0, RGB(0, 0, 255), RGB(255, 255, 0), 75, 140, 0, 2);
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonStop(IHTMLElement* /*pElement*/)
{
	KillTimer(1);
	SetElementText(_T("test"), _bstr_t(L"Stopped!"));

	m_pVCam->StopPlay();
	m_pVCam->StopCaptureScreen();
	return S_OK;
}

HRESULT CVCamCOMTestDlg::OnButtonConfig(IHTMLElement* /*pElement*/)
{
	// Q: how to save the settings?
	// A: Restart the driver (or reboot PC)
	m_pVCam->ChangeDefaultVideoSize(5); // 640 x 480 (2 means 320 x 240)
	m_pVCam->ChangeDefaultFPS(10);
	SetElementHtml(_T("test"), _bstr_t(L"VCam's default frame rate is set to 10, " \
		L"and video size is changed to 640 x 480. <br/>" \
		L"<strong>Please restart the driver (driver_restart.bat) to take effect!</strong>"));
	return S_OK;
}

void CVCamCOMTestDlg::OnTimer(UINT nIDEvent)
{
	CString info;
	ULONG pos, dur;
	m_pVCam->get_CurrentVideoPosition(&pos);
	pos /= 1000;
	m_pVCam->get_CurrentVideoDuration(&dur);
	dur /= 1000;

	int nCurrentHours   = (int) (pos / ( 3600 ));
	int nCurrentMinutes = (int) (( pos / 60 ) - ( nCurrentHours * 60 ));
	int nCurrentSeconds = (int) (( pos ) - ( nCurrentMinutes * 60 ));

	int nDurationHours   = (int) (dur / ( 3600 ));
	int nDurationMinutes = (int) (( dur / 60 ) - ( nDurationHours * 60 ));
	int nDurationSeconds = (int) (( dur ) - ( nDurationMinutes * 60 ));

	info.Format(_T("Current video position: %2.2ld:%2.2ld:%2.2ld / %2.2ld:%2.2ld:%2.2ld"), 
		nCurrentHours, nCurrentMinutes, nCurrentSeconds, nDurationHours, nDurationMinutes, nDurationSeconds);
	SetElementText(_T("test"), _bstr_t(info));

	VARIANT_BOOL vbPlaying;
	m_pVCam->get_IsPlaying(&vbPlaying);
	if (pos + 1 > dur && (vbPlaying == VARIANT_FALSE)) {
		SetElementText(_T("test"), _bstr_t(L"Play finished!"));
		KillTimer(1);
	}

	CDHtmlDialog::OnTimer(nIDEvent);
}